Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.bag
Class SynchronizedBag

    java.lang.Object
      org.apache.commons.collections.collection.SynchronizedCollection
          org.apache.commons.collections.bag.SynchronizedBag

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection, Bag

Direct Known Subclasses:
  SynchronizedSortedBag

    public class SynchronizedBag

extends SynchronizedCollection
implements Bag

Decorates another `Bag` to synchronize its behaviour for a multi-threaded environment.

Methods are synchronized, then forwarded to the decorated bag. Iterators must be separately synchronized around the loop.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.commons.collections.collection.SynchronizedCollection
`collection, lock`

Constructor Summary
`protected` | `SynchronizedBag(Bag bag)` Constructor that wraps (not copies).
`protected` | `SynchronizedBag(Bag bag, java.lang.Object lock)` Constructor that wraps (not copies).

Method Summary
`boolean` | `add(java.lang.Object object, int count)` Adds `nCopies` copies of the specified object to the Bag.
`static Bag` | `decorate(Bag bag)` Factory method to create a synchronized bag.
`protected Bag` | `getBag()` Gets the bag being decorated.
`int` | `getCount(java.lang.Object object)` Returns the number of occurrences (cardinality) of the given object currently in the bag.
`boolean` | `remove(java.lang.Object object, int count)` Removes `nCopies` copies of the specified object from the Bag.
`java.util.Set` | `uniqueSet()` Returns a `Set` of unique elements in the Bag.

Methods inherited from class org.apache.commons.collections.collection.SynchronizedCollection
`add, addAll, clear, contains, containsAll, decorate, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.Bag
`add, containsAll, iterator, remove, removeAll, retainAll, size`

Methods inherited from interface java.util.Collection
`addAll, clear, contains, equals, hashCode, isEmpty, toArray, toArray`

Constructor Detail

### SynchronizedBag

    protected SynchronizedBag(Bag bag)

  Constructor that wraps (not copies).

  Parameters:
    `bag` - the bag to decorate, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if bag is null

### SynchronizedBag

    protected SynchronizedBag(Bag bag,
                              java.lang.Object lock)

  Constructor that wraps (not copies).

  Parameters:
    `bag` - the bag to decorate, must not be null
    `lock` - the lock to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if bag is null

Method Detail

### decorate

    public static Bag decorate(Bag bag)

  Factory method to create a synchronized bag.

  Parameters:
    `bag` - the bag to decorate, must not be null
  Returns:
    a new synchronized Bag
  Throws:
    `java.lang.IllegalArgumentException` - if bag is null

### getBag

    protected Bag getBag()

  Gets the bag being decorated.

  Returns:
    the decorated bag

### add

    public boolean add(java.lang.Object object,
                       int count)

  Description copied from interface: `Bag`
  Adds `nCopies` copies of the specified object to the Bag.

  If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

  Specified by:
    `add` in interface `Bag`
  Parameters:
    `object` - the object to add
    `count` - the number of copies to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### remove

    public boolean remove(java.lang.Object object,
                          int count)

  Description copied from interface: `Bag`
  Removes `nCopies` copies of the specified object from the Bag.

  If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

  Specified by:
    `remove` in interface `Bag`
  Parameters:
    `object` - the object to remove
    `count` - the number of copies to remove
  Returns:
    `true` if this call changed the collection

### uniqueSet

    public java.util.Set uniqueSet()

  Description copied from interface: `Bag`
  Returns a `Set` of unique elements in the Bag.

  Uniqueness constraints are the same as those in `Set`.

  Specified by:
    `uniqueSet` in interface `Bag`
  Returns:
    the Set of unique Bag elements

### getCount

    public int getCount(java.lang.Object object)

  Description copied from interface: `Bag`
  Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.

  Specified by:
    `getCount` in interface `Bag`
  Parameters:
    `object` - the object to search for
  Returns:
    the number of occurrences of the object, zero if not found

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.